<center><a href="ex87.c">Actual source code: ex87.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:31+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>() for SBAIJ matrices\n\n"</font>;

<a name="line4"> 4: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line8">  8: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line9">  9: </a>{
<a name="line10"> 10: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            BAIJ,SBAIJ,*subBAIJ,*subSBAIJ;
<a name="line11"> 11: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>    viewer;
<a name="line12"> 12: </a>  char           file[PETSC_MAX_PATH_LEN];
<a name="line13"> 13: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line15"> 15: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       n = 2,issize;
<a name="line16"> 16: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line17"> 17: </a>  <A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A>             is,iss[2];

<a name="line19"> 19: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);
<a name="line20"> 20: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-f"</font>,file,PETSC_MAX_PATH_LEN-1,&amp;flg);
<a name="line21"> 21: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,file,FILE_MODE_READ,&amp;viewer);
<a name="line22"> 22: </a>  <A href="../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(viewer,<A href="../../../../docs/manualpages/Mat/MATMPIBAIJ.html#MATMPIBAIJ">MATMPIBAIJ</A>,&amp;BAIJ);
<a name="line23"> 23: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer);
<a name="line24"> 24: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,file,FILE_MODE_READ,&amp;viewer);
<a name="line25"> 25: </a>  <A href="../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(viewer,<A href="../../../../docs/manualpages/Mat/MATMPISBAIJ.html#MATMPISBAIJ">MATMPISBAIJ</A>,&amp;SBAIJ);
<a name="line26"> 26: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer);

<a name="line28"> 28: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(BAIJ,&amp;issize,0);
<a name="line29"> 29: </a>  issize = 9;
<a name="line30"> 30: </a>  <A href="../../../../docs/manualpages/IS/ISCreateStride.html#ISCreateStride">ISCreateStride</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,issize,0,1,&amp;is);
<a name="line31"> 31: </a>  iss[0] = is;iss[1] = is;
<a name="line32"> 32: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(BAIJ,n,iss,iss,MAT_INITIAL_MATRIX,&amp;subBAIJ);
<a name="line33"> 33: </a>  <A href="../../../../docs/manualpages/Mat/MatGetSubMatrices.html#MatGetSubMatrices">MatGetSubMatrices</A>(SBAIJ,n,iss,iss,MAT_INITIAL_MATRIX,&amp;subSBAIJ);

<a name="line35"> 35: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line36"> 36: </a><font color="#A020F0">#if defined(PETSC_USE_SOCKET_VIEWER)</font>
<a name="line37"> 37: </a>  <font color="#4169E1">if</font> (!<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>) {
<a name="line38"> 38: </a>    <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(subBAIJ[0],<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_SOCKET_SELF.html#PETSC_VIEWER_SOCKET_SELF">PETSC_VIEWER_SOCKET_SELF</A>);
<a name="line39"> 39: </a>    <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(subSBAIJ[0],<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_SOCKET_SELF.html#PETSC_VIEWER_SOCKET_SELF">PETSC_VIEWER_SOCKET_SELF</A>);
<a name="line40"> 40: </a>  }
<a name="line41"> 41: </a><font color="#A020F0">#endif</font>

<a name="line43"> 43: </a>  <font color="#B22222">/* Free data structures */</font>
<a name="line44"> 44: </a>  <A href="../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(is);
<a name="line45"> 45: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroyMatrices.html#MatDestroyMatrices">MatDestroyMatrices</A>(n,&amp;subBAIJ);
<a name="line46"> 46: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroyMatrices.html#MatDestroyMatrices">MatDestroyMatrices</A>(n,&amp;subSBAIJ);
<a name="line47"> 47: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(BAIJ);
<a name="line48"> 48: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(SBAIJ);

<a name="line50"> 50: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line51"> 51: </a>  <font color="#4169E1">return</font> 0;
<a name="line52"> 52: </a>}


</pre>
</body>

</html>
